#include "Keyboard.h"

#include <CyberLib.h>

#define KEY_DELAY 200   // Задержка для устранения дребезка в мс

extern unsigned long curTic;

byte key = keyNONE;  // клавиша нажатая сейчас
byte keyLast1 = keyNONE;
byte keyCnt;

#define KEY_STATE_WAIT 0
#define KEY_STATE_DEBOUNCE 1
#define KEY_STATE_RELEASE 2

static byte keyState = KEY_STATE_WAIT; // Статус нажатия клавиши false - Ожидание нажатия кнопки true - клавиша нажата но
static uint32_t keyStartTic; // Время нажатия новой клавиши

void keySetWaitRelease() {
  keyState = KEY_STATE_RELEASE;
}

uint16_t adc_key_in;

// Чтение клавиши с аналоговой клавиатуры. Возвращает код клавиши
byte keyGet(){
    //uint16_t adc_key_in = A0_Read; // читаем данные с аналогового порта
    adc_key_in = A0_Read; // читаем данные с аналогового порта

    // Напряжение при нажатии кнокок : V * 1024 / 5 = V * 205
    // Right    = 0
    // UP       = 160
    // Down     = 380
    // Left     = 580
    // Central  = 870
            // Прибавляем 50 чтобы расширить диапазон
    if (adc_key_in > 1000) key = keyNONE;
    else if (adc_key_in < 50) key = keyRIGHT;
    else if (adc_key_in < 190) key = keyUP;
    else if (adc_key_in < 430) key = keyDOWN;
    else if (adc_key_in < 630) key = keyLEFT;
    else if (adc_key_in < 950) key = keyOK;
    else key = keyNONE;

    switch (keyState) {
    case KEY_STATE_WAIT: // Состояние ожидания нажатия кнопки
      if (key>keyNONE) {
        keyLast1 = key;
        keyCnt = 0;
        keyStartTic = curTic;
        keyState = KEY_STATE_DEBOUNCE;
      }
      break;
    case KEY_STATE_DEBOUNCE: // Клавиша нажата
      if (key != keyLast1) {
        keyState = KEY_STATE_WAIT;
      } else if ((curTic-keyStartTic) > KEY_DELAY) { // Устраняем дребизг
          keyCnt++;
          keyStartTic = curTic;
          return key;
      } else if (keyCnt > 0) {// Удержание клавиши но интервал врмени еще не пройден
          return key;
      }
      break;
    case KEY_STATE_RELEASE: // Ожидни отпускания клавиши
      if (key == keyNONE) {
        keyState = KEY_STATE_WAIT;
      } else return keyWAIT;
      break;
    }
    return keyNONE;
}
