#include <LCD.h>

#include <CyberLib.h>                                   //библиотека-ускоритель скетчей
#include <LiquidCrystal_I2C.h>                          //библиотека дисплея LCD1602 i2c

//LiquidCrystal_I2C lcd(0x27, 16, 2);//-                    //вместо (0x3f) или (0x27) указываем адрес своего дисплея
LiquidCrystal_I2C lcd(0x3F, 16, 2);                     //вместо (0x3f) или (0x27) указываем адрес своего дисплея

extern byte Output1, Output2;                                //выход ПИД регулятора ВИ и НИ соответственно

byte  rfTempRound1=0, rfTempRound2=0;                                     //текущая температура(измеренная max6675) ВИ и НИ соответственно

// MAX6675 functions
double max6675_read_temp (byte topORbottom)
{ byte i;
  int tmp = 0;
  if (topORbottom == 1)D9_Low; else D8_Low;                      //Останавливаем преобразование CS=0
  //delayMicroseconds(10);
  asm volatile(" nop"        "\n\t");                            //Задержка в 1 пустую команду
  for (i = 15; i > 0; i--)                                       //Счётчик для чтения, будем читать 16 бит
  { D7_High;                                                     //Устанавливаем вывод clk в единицу CLK=1
    asm volatile(" nop"        "\n\t");                          //Задержка в 1 пустую команду
    if ( D6_Read )                                               //Читаем бит c DO
      tmp |= (1 << i);                                           //если он не равен нулю, то записываем в соответствующий бит переменной tmp единицу
    D7_Low;                                                      //Устанавливаем вывод clk в ноль CLK=0
    asm volatile(" nop"        "\n\t");
  }                                                              //Задержка в 1 пустую команду
  D9_High;                                                       //Запускаем преобразование CS=1
  D8_High;
  if (tmp & 0x4) return 255;                                     //Проверяем 3 бит результата чтения и если он равен единице, значит произошла ошибка
  else return (tmp >> 3) * 0.25;                               //Результат сдвигаем на 3 позиции вправо и домножаем на 0,25
}

void lcdTemp() {
  lcd.setCursor(12, 0);
  if (rfTempRound1 > 250) {
    lcd.print("Er");lcd.print(" ");
  } else {
    lcd.print(rfTempRound1);lcd.write(byte(0));lcd.print(" ");
  };
  lcd.setCursor(12, 1);
  if (rfTempRound2 > 250) {
    lcd.print("Er");lcd.print(" ");
  } else {
    lcd.print(rfTempRound2);lcd.write(byte(0));lcd.print(" ");
  };
}

void beep_(uint16_t dur, uint16_t frq)
{
  //return; //-
  //dur=(1000/frq)*dur;                                          //расчет длительности бипа
  uint16_t per = 500000 / frq;                                   //длительность. полупериода в мкс
  dur = dur / (per / 250) * 2;
  for (uint16_t i = 0; i < dur; i++)
  {
    D10_High;
    delay_us(per);
    D10_Low;
    delay_us(per);
  }
}
