#include "PID.h"

#include <CyberLib.h>                                   //библиотека-ускоритель скетчей

#include "ProFile.h"

#include "Global.h"

extern pr profile;

byte Output1=0, Output2=0;                                  //выходная мощьность ПИД регулятора ВИ и НИ соответственно в %

#define ER_CNT 5

float E1[ER_CNT];
float E2[ER_CNT];

float pE1;
float pE2;

byte i1;
byte i2;

void initPid(void)
{
  for (byte i = 0; i < ER_CNT; i++) {
    E1[i]=0;
    E2[i]=0;    
  }

  i1=0;
  i2=0;
 
  pE1=0;
  pE2=0;
}

// ПИДы вычисляют мощьность от 0 до 100%
byte Pid1(double input, double setpoint)
{
  float E, P, I, D; //ошибка регулирования, П-составляющая, Д-составляющая 
  float out;

  E = setpoint - input;
  E1[i1]=E;

  P =  profile.kp1 * E;

  D = profile.kd1 * (E-pE1);
  pE1 = E;
  
  I = 0; for(float e:E1) I+=e;
  I = I * profile.ki1/10;

  out = P + I + D;

  #if (LOG==2)
    Serial.print(String(E,2)+";");
    Serial.print(String(P,2)+";");
    Serial.print(String(I,2)+";");
    Serial.print(String(D,2)+";");
    Serial.print(String(out,2)+";");
  #endif  

  if (out < 0) out=0;
  else if (out > 100)  out =100;

  i1++; if (i1>=ER_CNT) i1=0;

  return (byte)out;
}

byte Pid2(double input, double setpoint)
{
  float E, P, I, D; //ошибка регулирования, П-составляющая, Д-составляющая 
  float out;

  E = setpoint - input;
  E2[i2]=E;

  P =  profile.kp2 * E;

  D = profile.kd2 * (E-pE2);
  pE2 = E;
  
  I = 0;  for(float e:E2) I+=e;
  I = I * profile.ki2/10;

  out = P + I + D;

  #if (LOG==2)
    Serial.print(String(E,2)+";");
    Serial.print(String(P,2)+";");
    Serial.print(String(I,2)+";");
    Serial.print(String(D,2)+";");
    Serial.print(String(out,2)+";");
  #endif  

  if (out < 0) out=0;
  else if (out > 100)  out =100;

  i2++; if (i2>=ER_CNT) i2=0;

  return (byte)out;
}

// секция алгоритма Брезенхема
int er1 = 1;                                            //переменная для расчета переполнения в алгоритме Брезенхема для ВИ
int er2 = 1;                                            //переменная для расчета переполнения в алгоритме Брезенхема для НИ
int reg1;                                               //промежуточная переменная для алгоритма Брезенхема для ВИ
int reg2;                                               //промежуточная переменная для алгоритма Брезенхема для НИ

// Алгоритм
void OutPWR_TOP() {
  reg1 = Output1 + er1;                                  // reg1 выходная мощность в %, er- ошибка
  if (reg1 < 50) {
    D12_Low;                                             // дискретное управление ВИ
    er1 = reg1;                                          //
  } else {
    D12_High;                                            // дискретное управление ВИ
    er1 = reg1 - 100;
  }
}

void OutPWR_BOTTOM() {
  reg2 = Output2 + er2;                                  //задание выходной мощности в %, er- ошибка округления
  if (reg2 < 50) {
    D11_Low;                                              //пин через который осуществляется дискретное управление НИ
    er2 = reg2;                                          //reg- переменная для расчетов
  } else {
    D11_High;                                             //пин через который осуществляется дискретное управление НИ
    er2 = reg2 - 100;
  }
}

void Dimming()
{
  OutPWR_TOP();
  OutPWR_BOTTOM();
}

